using System;
using System.Threading;
using System.Collections.Generic;
using System.Text;

namespace Localization
{
    class Program
    {
        static void Main(string[] args)
        {
           
            Console.WriteLine(ApplicationText.Welcome);
            
            Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("fr-CA");            
            Console.WriteLine(ApplicationText.Welcome);

            // this displays the french-canadian way of saying "the weekend"
            Console.WriteLine(ApplicationText.weekend);

            // this displays the french-neutral way of saying "the weekend"
            // because there are no localized resources for fr-BE in this app,
            // so it drops down to fr-neutral.
            Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("fr-BE");
            Console.WriteLine(ApplicationText.weekend);

            // this displays the neutral (default) way of saying "the weekend" (english)
            // because there are no localized resources for hi-IN.
            Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("hi-IN");
            Console.WriteLine(ApplicationText.weekend);

            Console.ReadLine();
        }
    }
}
