using System;
using System.IO;
using System.Security;
using System.Security.Cryptography;
using System.Collections.Generic;
using System.Text;

namespace HashVerify
{
    class Program
    {
        static void Main(string[] args)
        {
            string verifiableMesage = "It was the best of times, it was the worst of times.";
            string wrongMessage = "It was the best of times it was the worst of times";

            SHA1Managed sha = new SHA1Managed();
            byte[] verifiableMessageHash = sha.ComputeHash(
                System.Text.ASCIIEncoding.ASCII.GetBytes(verifiableMesage));
            byte[] wrongMessageHash = sha.ComputeHash(
                System.Text.ASCIIEncoding.ASCII.GetBytes(wrongMessage));

            // note that we never manually decrypt the sig, that's done by the sig verifier
            FileStream fs = new FileStream(@"..\..\..\..\signedHash.dat", FileMode.Open);
            byte[] fileHash = new byte[fs.Length];
            fs.Read(fileHash, 0, (int)fs.Length);
            fs.Close();

            // get jane's key so we can decrypt the hash
            StreamReader sr = File.OpenText(@"..\..\..\..\JanesKey.xml");
            string janesKey = sr.ReadToEnd();
            sr.Close();

            RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
            rsa.FromXmlString(janesKey);

            RSAPKCS1SignatureDeformatter sigDeformatter = new RSAPKCS1SignatureDeformatter(rsa);
            sigDeformatter.SetHashAlgorithm("SHA1");
            if (sigDeformatter.VerifySignature(verifiableMessageHash, fileHash))
            {
                Console.WriteLine("The real message is verified as untampered.");
            }
            if (sigDeformatter.VerifySignature(wrongMessageHash, fileHash) == false)
            {
                Console.WriteLine("The fake message is verified as fake.");
            }
            else
            {
                Console.WriteLine("This should statistically never happen.");
            }
            
            Console.ReadLine();
        }
    }
}
