using System;
using System.Collections.Generic;
using System.Text;

namespace ConnectedDataSet
{
    class Program
    {
        static void Main(string[] args)
        {            
            ConnectedOrderDataSetTableAdapters.OrdersTableAdapter orderTa =
                new ConnectedOrderDataSetTableAdapters.OrdersTableAdapter();
            ConnectedOrderDataSetTableAdapters.OrderItemsTableAdapter orderItemsTa =
                new ConnectedOrderDataSetTableAdapters.OrderItemsTableAdapter();
         
            ConnectedOrderDataSet orderData = new ConnectedOrderDataSet();
            orderTa.Fill(orderData.Orders);
            orderItemsTa.Fill(orderData.OrderItems);

            foreach (ConnectedOrderDataSet.OrdersRow order in orderData.Orders)
            {
                Console.WriteLine("Order {0} Purchased by {1} on {2}", order.OrderID,
                    order.ShipTo, order.OrderDate.ToShortDateString());
                foreach (ConnectedOrderDataSet.OrderItemsRow orderItem in order.GetOrderItemsRows())
                {
                    Console.WriteLine("\t{0} - {1} for ${2:00.00}",
                        orderItem.SKU, orderItem.ItemDescription, orderItem.Price);
                }
            }

            // modify the first order
            orderData.Orders[0].ShipTo = "Modified User";
            orderTa.Update(orderData.Orders);

            orderTa.ClearBeforeFill = true;
            orderTa.FillByCity(orderData.Orders, "Somewhere");
            Console.WriteLine("Orders filtered by city: Somewhere");
            foreach (ConnectedOrderDataSet.OrdersRow order in orderData.Orders)
            {
                Console.WriteLine("Order {0} Purchased by {1} on {2} with {3} order items.", order.OrderID,
                    order.ShipTo, order.OrderDate.ToShortDateString(), order.GetOrderItemsRows().Length);
  
            }

            Console.WriteLine("Total sum of all purchases in DataSet: ${0:00.00}",
                orderData.SumAllOrders());

            Console.ReadLine();
        }
    }
}
