using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// Really good guideline for out-of-proc state:
/// 1. structs only
/// 2. lightweight
/// 3. must be serializable
/// 4. use only public fields, no accessors
/// 5. no private members
/// 6. constructors cannot create a state that is unachievable
///    through simple property/field setting (serialization/deserialization)
/// </summary>
[Serializable()]
public struct Customer
{
    public string FirstName;
    public string LastName;
    
    public Customer(string last, string first)
    {
        FirstName = first;
        LastName = last;
    }
}
